"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Code = void 0;
const kittik_shape_basic_1 = require("kittik-shape-basic");
const default_1 = require("./themes/default");
const js_beautify_1 = require("js-beautify");
const redeyed_1 = __importDefault(require("redeyed"));
class Code extends kittik_shape_basic_1.Shape {
    get text() {
        return js_beautify_1.js_beautify(this.rawText, { indent_size: 2 });
    }
    set text(code) {
        this.rawText = code;
    }
    get width() {
        const lengths = this.text.split('\n').map((item) => item.length);
        return Math.max(...lengths).toString();
    }
    get height() {
        return this.text.split('\n').length.toString();
    }
    render(canvas) {
        super.render(canvas);
        const codeSplits = redeyed_1.default(this.text, default_1.DEFAULT_THEME).splits;
        const x = parseInt(this.x, 10);
        const y = parseInt(this.y, 10);
        canvas.moveTo(x, y);
        codeSplits.forEach((split) => {
            const code = split.replace(/__.*__/u, '');
            const color = (/__(?<color>.*)__/u).exec(split);
            if ((/\n/u).exec(code) === null) {
                canvas.foreground(color === null ? 'none' : color[1]);
                canvas.write(code);
            }
            else {
                canvas.moveTo(x, canvas.cursorY + 1).write(code.replace('\n', ''));
            }
        });
    }
}
exports.Code = Code;
//# sourceMappingURL=Code.js.map